SendDirectMessage
Sends an MQTT message directly to a specific client identified by its client ID.
SendDirectMessage targets a single client ID. The receiving client does not
need to subscribe to the topic, but the receiver's policy must allow iot:Receive on the specified topic.
Requires permission to access the SendDirectMessage action.
For more information about messaging costs, see AWS IoT Core
pricing
Request Syntax
POST /connections/clientId/messages?confirmation=confirmation&contentType=contentType&responseTopic=responseTopic&timeout=timeout&topic=topic HTTP/1.1
x-amz-mqtt5-user-properties: userProperties
x-amz-mqtt5-payload-format-indicator: payloadFormatIndicator
x-amz-mqtt5-correlation-data: correlationData
payload
URI Request Parameters
The request uses the following URI parameters.
- clientId
-
The unique identifier of the MQTT client to send the message to.
Client IDs must not exceed 128 characters and can't start with a dollar sign ($). MQTT client IDs must be URL encoded (percent-encoded) when they contain characters that are not valid in HTTP requests, such as spaces, forward slashes (/), and UTF-8 characters. For more information, see AWS IoT Core message broker and protocol limits and quotas.
Length Constraints: Minimum length of 1. Maximum length of 128.
Pattern:
^[^$].*Required: Yes
- confirmation
-
A Boolean value that specifies whether to wait for delivery confirmation from the receiving client.
When set to
true, the API delivers the message at QoS 1 and waits for the client to send a delivery confirmation (PUBACK) before returning a successful response. If delivery confirmation is not received within the specifiedtimeoutperiod, the API returns HTTP 504.When set to
false, the API delivers the message at QoS 0 and returns after AWS IoT Core attempts to deliver the message.Valid values:
true|falseDefault value:
false - contentType
-
The MQTT5 content type property forwarded to the receiving client (for example,
application/json). - correlationData
-
The base64-encoded binary data used by the sender of the request message to identify which request the response message is for when it's received.
correlationDatais an HTTP header value in the API. - payloadFormatIndicator
-
An
Enumstring value that indicates whether the payload is formatted as UTF-8.payloadFormatIndicatoris an HTTP header value in the API.Valid Values:
UNSPECIFIED_BYTES | UTF8_DATA - responseTopic
-
A UTF-8 encoded string that's used as the topic name for a response message. The response topic describes the topic which the receiver should publish to as part of the request-response flow. The topic must not contain wildcard characters. For more information, see AWS IoT Core message broker and protocol limits and quotas.
- timeout
-
An integer that represents the maximum time, in seconds, to wait for a delivery confirmation (PUBACK) from the receiving client after the message has been delivered. This parameter is only used when
confirmationis set totrue. Ifconfirmationisfalse, this parameter is ignored.The total API response time may be higher than this value due to internal processing. Set your HTTP client timeout to a value greater than this parameter.
Valid range: 1 to 15 seconds.
Default value:
5seconds. - topic
-
The topic of the outbound MQTT Publish message to the receiving client. For more information, see AWS IoT Core message broker and protocol limits and quotas.
Required: Yes
- userProperties
-
A JSON string that contains an array of JSON objects. If you don't use AWS SDK or AWS CLI, you must encode the JSON string to base64 format before adding it to the HTTP header.
userPropertiesis an HTTP header value in the API.For MQTT 3.1.1 clients, user properties are silently dropped.
The following example
userPropertiesparameter is a JSON string which represents two User Properties. Note that it needs to be base64-encoded:[{"deviceName": "alpha"}, {"deviceCnt": "45"}]
Request Body
The request accepts the following binary data.
- payload
-
The message body. MQTT accepts text, binary, and empty (null) message payloads.
Response Syntax
HTTP/1.1 200
Content-type: application/json
{
"message": "string",
"traceId": "string"
}
Response Elements
If the action is successful, the service sends back an HTTP 200 response.
The following data is returned in JSON format by the service.
Errors
- ForbiddenException
-
The caller isn't authorized to make the request.
HTTP Status Code: 403
- GatewayTimeoutException
-
The delivery confirmation was not received from the client within the specified timeout period.
- message
-
The message for the exception.
HTTP Status Code: 504
- InternalFailureException
-
An unexpected error has occurred.
- message
-
The message for the exception.
HTTP Status Code: 500
- InvalidRequestException
-
The request is not valid.
- message
-
The message for the exception.
HTTP Status Code: 400
- RequestEntityTooLargeException
-
The payload exceeds the maximum size allowed.
- message
-
The message for the exception.
HTTP Status Code: 413
- ResourceNotFoundException
-
The specified resource does not exist.
- message
-
The message for the exception.
HTTP Status Code: 404
- ThrottlingException
-
The rate exceeds the limit.
- message
-
The message for the exception.
HTTP Status Code: 429
- UnauthorizedException
-
You are not authorized to perform this operation.
- message
-
The message for the exception.
HTTP Status Code: 401
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: